#include "chkutil.h"

/*
 * argv[1] - input filename
 * argv[2] - team output filename
 * argv[3] - correct output filename
 */

int main(int argc, char **argv)
{
  FILE *team_out, *corr_out;
  int team_v, corr_v;

  if (argc != 4) fatal_CF("wrong number of parameters");
  if (!(team_out = fopen(argv[2], "r")))
    fatal_PE("team output `%s' does not exist", argv[2]);
  if (fscanf(team_out, "%d", &team_v) != 1)
    fatal_PE("cannot read team output");
  fscanf(team_out, " ");
  if (getc(team_out) != EOF)
    fatal_PE("garbage in team output");
  fclose(team_out);

  if (!(corr_out = fopen(argv[3], "r")))
    fatal_CF("correct output `%s' does not exist", argv[3]);
  if (fscanf(corr_out, "%d", &corr_v) != 1)
    fatal_CF("cannot read correct output");
  fscanf(corr_out, " ");
  if (getc(corr_out) != EOF)
    fatal_CF("garbage in correct output");
  fclose(corr_out);

  if (team_v != corr_v)
    fatal_WA("answers differ: team %d, correct %d",
             team_v, corr_v);

  fprintf(stderr, "OK\n");
  return 0;
}

/*
 * Local variables:
 *  compile-command: "gcc -Wall -g check_f.c -o check_f"
 * End:
 */
